import HTMLElement from '../nodes/basic/html-element/HTMLElement';
/**
 * Custom elements registry.
 */
export default class CustomElementRegistry {
    private _callbacks;
    private _registry;
    /**
     * Defines a custom element class.
     *
     * @param tagName Tag name of element.
     * @param elementClass Element class.
     */
    define(tagName: string, elementClass: typeof HTMLElement): void;
    /**
     * Returns a defined element class.
     *
     * @param tagName Tag name of element.
     * @param HTMLElement class defined.
     */
    get(tagName: string): typeof HTMLElement;
    /**
     * Upgrades it.
     */
    upgrade(): void;
    /**
     * When defined.
     *
     * @param tagName Tag name of element.
     * @returns Promise.
     */
    whenDefined(tagName: string): Promise<void>;
}
