"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Document_1 = __importDefault(require("../nodes/basic/document/Document"));
var HTMLParser_1 = __importDefault(require("../html-parser/HTMLParser"));
/**
 * HTML parser.
 */
var DOMParser = /** @class */ (function () {
    function DOMParser() {
    }
    /**
     * Parses HTML and returns a root element.
     *
     * @param string HTML data.
     * @param mimeType Mime type.
     * @return Root element.
     */
    DOMParser.prototype.parseFromString = function (string, mimeType) {
        if (!mimeType) {
            throw new Error('Second parameter "mimeType" is mandatory.');
        }
        if (mimeType !== 'text/html') {
            throw new Error('The DOMParser in Happy DOM only supports the mime type "text/html".');
        }
        var ownerDocument = this.constructor.ownerDocument;
        var newDocument = new Document_1.default(ownerDocument.defaultView);
        var root = HTMLParser_1.default.parse(newDocument, string);
        var documentElement = root.querySelector('html');
        newDocument.documentElement.parentNode.removeChild(newDocument.documentElement);
        if (documentElement) {
            newDocument.appendChild(documentElement);
        }
        else {
            var documentElement_1 = newDocument.createElement('html');
            var bodyElement = newDocument.createElement('body');
            var headElement = newDocument.createElement('head');
            for (var _i = 0, _a = root.childNodes.slice(); _i < _a.length; _i++) {
                var child = _a[_i];
                bodyElement.appendChild(child);
            }
            documentElement_1.appendChild(headElement);
            documentElement_1.appendChild(bodyElement);
            newDocument.appendChild(documentElement_1);
        }
        return newDocument;
    };
    DOMParser.ownerDocument = null;
    return DOMParser;
}());
exports.default = DOMParser;
//# sourceMappingURL=DOMParser.js.map