import Element from '../nodes/basic/element/Element';
import Document from '../nodes/basic/document/Document';
/**
 * HTML parser.
 */
export default class HTMLParser {
    /**
     * Parses HTML and returns a root element.
     *
     * @param  {Document} document Document.
     * @param  data HTML data.
     * @return Root element.
     */
    static parse(document: Document, data: string): Element;
    /**
     * Appends text and comment nodes.
     *
     * @param  {Document} document Document.
     * @param  node Node.
     * @param  text Text to search in.
     */
    private static appendTextAndCommentNodes;
    /**
     * Returns text and comment nodes from a text.
     *
     * @param  {Document} document Document.
     * @param  text Text to search in.
     * @returns Nodes.
     */
    private static getTextAndCommentNodes;
}
