import Element from '../nodes/basic/element/Element';
import ShadowRoot from '../nodes/basic/shadow-root/ShadowRoot';
/**
 * Utility for converting an element to string.
 *
 * @class QuerySelector
 */
export default class HTMLRenderer {
    /**
     * Renders an element as HTML.
     *
     * @param element Element to render.
     * @return Result.
     */
    static getOuterHTML(element: Element): string;
    /**
     * Renders an element as HTML.
     *
     * @param element Element to render.
     * @returns Result.
     */
    static getInnerHTML(element: Element | ShadowRoot): string;
    /**
     * Returns attributes as a string.
     *
     * @param element Element.
     * @return Attributes.
     */
    private static getAttributes;
}
