import Node from '../node/Node';
/**
 * CommentNode.
 */
export default class CommentNode extends Node {
    nodeType: number;
    _textContent: string;
    /**
     * Node name.
     *
     * @return Node name.
     */
    get nodeName(): string;
    /**
     * Returns text content.
     *
     * @return Text content.
     */
    get textContent(): string;
    /**
     * Sets text content.
     *
     * @param textContent Text content.
     */
    set textContent(textContent: string);
    /**
     * Returns node value.
     *
     * @return Node value.
     */
    get nodeValue(): string;
    /**
     * Sets node value.
     *
     * @param nodeValue Node value.
     */
    set nodeValue(nodeValue: string);
    /**
     * Returns data.
     *
     * @return Data.
     */
    get data(): string;
    /**
     * Sets data.
     *
     * @param data Data.
     */
    set data(nodeValue: string);
    /**
     * Converts to string.
     *
     * @return String.
     */
    toString(): string;
}
