import Element from '../element/Element';
/**
 * HTMLElement.
 */
export default class HTMLElement extends Element {
    style: {
        [k: string]: string;
    };
    tabIndex: number;
    offsetHeight: number;
    offsetWidth: number;
    offsetLeft: number;
    offsetTop: number;
    clientHeight: number;
    clientWidth: number;
    /**
     * Returns inner text.
     *
     * @return Text.
     */
    get innerText(): string;
    /**
     * Sets inner text.
     *
     * @param text Text.
     */
    set innerText(text: string);
    /**
     * Triggers a click event.
     */
    click(): void;
    /**
     * Triggers a blur event.
     */
    blur(): void;
    /**
     * Triggers a focus event.
     */
    focus(): void;
}
