import HTMLElement from '../../basic/html-element/HTMLElement';
import Element from '../../basic/element/Element';
/**
 * HTMLFormElement.
 */
export default class HTMLFormElement extends HTMLElement {
    name: string;
    method: string;
    target: string;
    action: string;
    encoding: string;
    enctype: string;
    acceptCharset: string;
    autocomplete: string;
    noValidate: string;
    /**
     * Returns input elements.
     *
     * @returns Elements.
     */
    get elements(): Element[];
    /**
     * Returns number of input elements.
     *
     * @return Length.
     */
    get length(): number;
    /**
     * Submits form.
     */
    submit(): void;
    /**
     * Resets form.
     */
    reset(): void;
    /**
     * Reports validity.
     */
    reportValidity(): void;
    /**
     * Checks validity.
     *
     * @return "true" if validation does'nt fail.
     */
    checkValidity(): boolean;
    /**
     * @override
     */
    _setAttributeProperty(name: string, value: string): void;
}
