import HTMLElement from '../../basic/html-element/HTMLElement';
import Node from '../../basic/node/Node';
import HTMLFormElement from '../form/HTMLFormElement';
/**
 * HTMLTextAreaElement.
 */
export default class HTMLTextAreaElement extends HTMLElement {
    form: HTMLFormElement;
    name: string;
    readonly type = "textarea";
    disabled: boolean;
    autofocus: boolean;
    required: boolean;
    _value: string;
    autocomplete: string;
    minLength: number;
    maxLength: number;
    placeholder: string;
    readOnly: boolean;
    selectionStart: number;
    selectionEnd: number;
    selectionDirection: string;
    defaultValue: string;
    inputmode: string;
    /**
     * Returns value.
     *
     * @return Value.
     */
    get value(): string;
    /**
     * Sets value.
     *
     * @param value Value.
     */
    set value(value: string);
    /**
     * Returns text length.
     *
     * @param Text length.
     */
    get textLength(): number;
    /**
     * @override
     */
    appendChild(node: Node): Node;
    /**
     * Remove Child element from childNodes array.
     *
     * @param node Node to remove
     */
    removeChild(node: Node): void;
    /**
     * Inserts a node before another.
     *
     * @param newNode Node to insert.
     * @param referenceNode Node to insert before.
     * @return Inserted node.
     */
    insertBefore(newNode: Node, referenceNode: Node): Node;
    /**
     * Checks validity.
     *
     * @return "true" if validation does'nt fail.
     */
    checkValidity(): boolean;
}
